' ************************************************************************************************
' Program: Subroutine_Average_Growth.prg                                                         *
'                                                                                                *
' Purpose: This subroutine calculates and returns a series' average growth rate over a           *
'          specified period. Example:                                                            *
'                                                                                                *
'          SAMPLE growth_period 1949 1973                                                        *
'          call average_growth(qgdpfe, @pagefreq, growth_period)                                 *
'                                                                                                *
' Author: Bob Shackleton                                                                         *
' Date Created: May 13, 2011                                                                     *
' ************************************************************************************************

SUBROUTINE average_growth(SERIES series_name, STRING frequency, STRING %first, STRING %last)

' Determine data frequency

!freq = 0

IF frequency = "A" THEN
     !freq = 1
ELSE
     IF frequency = "Q" THEN
          !freq = 4
     ELSE
          IF frequency = "M" THEN
               !freq = 12
          ELSE
               @uiprompt("Frequency Problem in Average Growth Subroutine")
               STOP
          ENDIF
     ENDIF
ENDIF

%original_first = @word(@pagesmpl, 1)
%original_last = @word(@pagesmpl, 2)

smpl {%first} {%last}

scalar average_growth = 0.0

scalar average_growth = ((@elem(series_name, %last) _
                      / @elem(series_name, %first))^(1/ ((@obssmpl-1) / {!freq})) - 1) * 100

smpl {%original_first} {%original_last}

ENDSUB 
