' ************************************************************************************************

subroutine local dif(matrix DIF, scalar dd, scalar n, scalar p)

' ************************************************************************************************
'     PURPOSE: Generate a diferentiation matrix DIF(n X n)
' ************************************************************************************************
'     SYNTAX:  matrix DIF
'              call dif (DIF, dd, n, p)
' ************************************************************************************************
'     OUTPUT:  n x n temporal diferentiation matrix DIF(n x n)
' ************************************************************************************************
'     INPUT:   DIF:     temporal diferentiation matrix name, have to be declared before subroutine
'              dd:      order of diferentiation
'                   dd=0     levels => DIF=I
'                   dd=1     first order diferentiation => DIF=DIF
'                   dd=2     second order diferentiation  => DIF=DIF*DIF
'              n:       number of high frequency data points
'              p:       modified / not modified
'                   p=0      not modified (minimization of first correction, x0=y0)
'                   p=1      truncted first/second row/third row (x0 <> y0)
' ************************************************************************************************
'     LIBRARY:          
' ************************************************************************************************
'     writen by:
'     Slawomir Dudek
'     MOF 
' ************************************************************************************************
'
'     Generation of diferentiation matrix DIF

if p=0 then

if dd=0 then
     matrix DIF=@identity(n)
else
     if dd=1 then
          vector(n-1) diag1=-1
          matrix (n, n) DIF
          DIF=@makediagonal(diag1,-1) + @identity(n)
          delete diag1
     else
          if dd=2 then
               vector(n-1) diag1=-1
               matrix (n, n) DIF
               DIF=@makediagonal(diag1,-1) + @identity(n)
               matrix DIF=DIF*DIF
               else
               statusline   ERROR!!! DIF() subroutine !!!*** Improper value of option parameter [dd: = (0 to 2)] ***!!!
               stop 
          endif
     endif
endif

else

if p=1 then

if dd=0 then
     matrix DIF=@identity(n)
else
     if dd=1 then
          vector(n-1) diag1=-1
          matrix (n, n) DIF_temp
          DIF_temp=@makediagonal(diag1,-1) + @identity(n)
          matrix DIF = @subextract(DIF_temp,2,1, n, n)
          delete diag1 DIF_temp

     else
          if dd=2 then
               vector(n-1) diag1=-1
               matrix (n, n) DIF_temp
               DIF_temp=@makediagonal(diag1,-1) + @identity(n)
               matrix DIF_temp1=DIF_temp*DIF_temp
               matrix DIF = @subextract(DIF_temp1,3,1, n, n)
               delete diag1 DIF_temp DIF_temp1
          else
          statusline   ERROR!!! DIF() subroutine !!!*** Improper value of option parameter [dd: = (0 to 2)] ***!!!
          stop
          endif
     endif
endif

else 
statusline ERROR!!! DIF() subroutine !!!*** Improper value of option parameter [p: = 0/1] ***!!!
stop

endif
endif

endsub

' ************************************************************************************************
